﻿{
  このソースコードをひな形として新しくプラグインを開発する場合は、
  PluginBaseユニット内を書き換えるだけでOKです。
  また、このソースコードはMITライセンス下において自由に使用できます。

  MIT License

  Copyright (c) 2018 Lyna

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
}
library ATOK_PLUGIN_TATSUYA;

{$WARN SYMBOL_PLATFORM OFF}
{$R *.res}

uses
  PluginBase in 'PluginBase.pas';

{ Export Functions }

function atok_plugin_get_major_version2: Integer; cdecl;
begin
  Result := PluginMajorVersion;
end;

function atok_plugin_get_minor_version2: Integer; cdecl;
begin
  Result := PluginMinorVersion;
end;

function atok_plugin_is_enable_text2: ByteBool; cdecl;
begin
  Result := PluginIsEnableText;
end;

function atok_plugin_is_corresponding_auto_search2: ByteBool; cdecl;
begin
  Result := PluginIsCorrespondingAutoSearch;
end;

procedure atok_plugin_run_preference2; cdecl;
begin
  // 環境設定の設定ボタン押下時に呼ばれる(設定がある場合はここで設定ダイアログを呼び出す)
  RunPreference;
end;

function atok_plugin_is_enable_candidate2: ByteBool; cdecl;
begin
  Result := PluginIsEnableCandidate;
end;

function CopyStringToBuffer(const Source: string; Buffer: PChar; Count: Integer): Integer;
begin
  if Length(Source) > Count then
  begin
    Result := 0;
  end
  else begin
    Move(Pointer(Source)^, Buffer^, Length(Source) * SizeOf(Char));
    Result := Length(Source);
  end;
end;

function atok_plugin_get_name2(Buffer: PChar; Count: Integer): Integer; cdecl;
begin
  Result := CopyStringToBuffer(PluginName, Buffer, Count);
end;

function atok_plugin_get_short_name2(Buffer: PChar; Count: Integer): Integer; cdecl;
begin
  Result := CopyStringToBuffer(PluginShortName, Buffer, Count);
end;

function atok_plugin_get_description2(Buffer: PChar; Count: Integer): Integer; cdecl;
begin
  Result := CopyStringToBuffer(PluginDescription, Buffer, Count);
end;

function atok_plugin_get_copyright2(Buffer: PChar; Count: Integer): Integer; cdecl;
begin
  Result := CopyStringToBuffer(PluginCopyright, Buffer, Count);
end;

function atok_plugin_initialize2: ByteBool;
begin
  // 初期化処理がある場合はここに書く
  Result := True;
end;

procedure atok_plugin_destroy2; cdecl;
begin
  // 終了時処理がある場合はここに書く
end;

function atok_plugin_run_setup: Integer; cdecl;
begin
  // セットアップ実行中に呼び出される
  Result := 2;
end;

function atok_plugin_run_uninstall: Integer; cdecl;
begin
  // アンインストール時に設定ファイルを消す等の処理がある場合はここに書く
  Result := 0;
end;

type
  TInternalAddCandidateProc = procedure(
    Handle: THandle;
    // 候補文字列
    CandidateText: PChar; CandidateCount: Integer;
    // 候補に対応するコメント(XHTML)
    CommentText: PChar; CommentCount: Integer;
    // 代替候補文字列
    Alternative: PChar; AlternativeCount: Integer;
    // 代替候補として実際にツールチップに表示される文字列
    AlternativeAliasText: PChar; AlternativeAliasCount: Integer;
    // 代替候補タイプ(-1=代替候補なし, 0=代替候補 1=代替候補をURLとして開く)
    AlternativeType: Integer;
    // 候補ウィンドウで候補文字列の右側に表示される文字列
    TagText: PChar; TagCount: Integer
  ); cdecl;

procedure atok_plugin_run_process2(PluginHandle: THandle; Functions: PPointerArray;
  RequestData: PByte; PluginHandle2: THandle); cdecl;
var
  inputText: string;
begin
  inputText := WideCharLenToString(PChar(RequestData + 0), PInteger(RequestData + $190)^);
  RunProcess(inputText,
    procedure(const Candidate: string; const Comment: string;
      const Alternative: string; const AlternativeAlias: string;
      AlternativeType: TAlternativeType; const Tag: string)
    begin
      TInternalAddCandidateProc(Functions[0])(
        PluginHandle,
        PChar(Candidate), Length(Candidate),
        PChar(Comment), Length(Comment),
        PChar(Alternative), Length(Alternative),
        PChar(AlternativeAlias), Length(AlternativeAlias),
        Ord(AlternativeType),
        PChar(Tag), Length(Tag)
      );
    end);
end;

exports
  atok_plugin_destroy2 index 1,
  atok_plugin_get_copyright2 index 2,
  atok_plugin_get_description2 index 3,
  atok_plugin_get_major_version2 index 4,
  atok_plugin_get_minor_version2 index 5,
  atok_plugin_get_name2 index 6,
  atok_plugin_get_short_name2 index 7,
  atok_plugin_initialize2 index 8,
  atok_plugin_is_corresponding_auto_search2 index 9,
  atok_plugin_is_enable_candidate2 index 10,
  atok_plugin_is_enable_text2 index 11,
  atok_plugin_run_preference2 index 12,
  atok_plugin_run_process2 index 13,
  atok_plugin_run_setup index 14,
  atok_plugin_run_uninstall index 15;

begin
end.
